/* Loading spinner */
@keyframes rotation {
  0% {
    transform: rotate(0deg);
  }
  100% {
    transform: rotate(360deg);
  }
}

.loading-spinner {
  display: none;
  width: 64px;
  height: 64px;
  border: 5px solid var(--secondary-bg-color);
  border-bottom-color: transparent;
  border-radius: 50%;
  box-sizing: border-box;
  animation: rotation 1s cubic-bezier(0.65, 0, 0.35, 1) infinite;
  z-index: 50;
}

.main-loading-spinner {
  position: fixed;
  left: 50%;
  top: 50%;
  translate: -50% -50%;
  width: 96px;
  height: 96px;
  border-width: 8px;
}

.main-loading-spinner-container {
  position: fixed;
  left: 50%;
  top: 50%;
  translate: -50% -50%;
  width: 170px;
  height: 170px;
  border-width: 8px;
  z-index: 50;
  display: none;
}

body.freeze,
body.loading {
  overflow: hidden;
}

body.loading .main-loading-spinner-container::before {
  position: fixed;
  content: "";
  top: 50%;
  left: 50%;
  z-index: 49;
  height: 170px;
  width: 170px;
  translate: -50% -50%;
  color: var(--main-text-color);
  border-width: 1px;
  border-color: var(--secondary-bg-color);
  border-style: solid;
  border-radius: 20px;
  box-shadow: var(--secondary-bg-color) 3px 3px;
  box-sizing: border-box;
  background-color: var(--main-bg-color);
}

body.loading::after {
  position: fixed;
  content: "";
  top: 0;
  left: 0;
  z-index: 48;
  height: 100vh;
  width: 100vw;
  border-radius: 20px;
  background-color: var(--main-bg-color);
  opacity: 0.5;
}

body.loading .main-loading-spinner,
body.loading .main-loading-spinner-container {
  display: inline-block;
}

/* Graphs */
.graph-box {
  min-height: 300px;
  position: relative;
}
.graph-box .loading-spinner {
  position: absolute;
  top: 50%;
  left: 50%;
  translate: -50% -50%;
  z-index: 50;
}

.graph-box.loading::before {
  position: absolute;
  content: "";
  top: 50%;
  left: 50%;
  z-index: 49;
  height: 96px;
  width: 96px;
  translate: -50% -50%;
  color: var(--main-text-color);
  border-width: 1px;
  border-color: var(--secondary-bg-color);
  border-style: solid;
  border-radius: 20px;
  box-shadow: var(--secondary-bg-color) 2px 2px;
  box-sizing: border-box;
  background-color: var(--main-bg-color);
  opacity: 0.9;
}

.graph-box.loading .loading-spinner {
  display: inline-block;
}

.graph-box:not(.loading) .loading-spinner {
  display: none;
}
